#include<stdio.h>
#include<stdlib.h>
#include<iostream>
#include<stdbool.h>
#include<string.h>
#include<vector>
#include<math.h>
#include<stdint.h>
#include<ctime>
#include<assert.h>
#include<fstream>
#include<bitset>

typedef struct board
{
	std::bitset<121> mine;
	std::bitset<121> next;
	std::bitset<121> prev;
	int step;
}board_t;

#define infinity 1000
#define infinitesimal -1000

int node_amo = 0;

bool legal_position(board_t &node, int x, int y);
std::string next_step(board_t &node); //Return the score of the path
board_t move(board_t &node, int choice);
void Print(board_t &node, int turn); //Print the board
int place_to_num(std::string);
std::string num_to_place(int num);

//***********************************************************************************

board_t move(board_t &node, int choice)
{
	board_t nextState = {node.mine, node.next, node.prev, node.step+1};
	if(choice < 121) {
		nextState.mine.set(choice);
		int dx[6] = { -1, -1, 0, 0, 1, 1 };
		int dy[6] = { 0, 1, -1, 1, -1, 0 };
		int x = choice / 11, y = choice % 11;
		for(int i = 0; i < 6; i++) {
			int tx = x + dx[i], ty = y + dy[i];
			int pos = tx*11 + ty;
			if(tx < 0 || tx > 10 || ty < 0 || ty > 10 || tx + ty < 5 || tx + ty > 15 || nextState.mine[pos] == 1) continue;
			if(nextState.mine[pos] == 0 && nextState.next[pos] == 0 && nextState.prev[pos] == 0) continue;
			int enemy = (nextState.next[pos] == 1)? 1 : 2;
			for(int j = 0; j < 11; j++) {
				if(tx < 0 || tx > 10 || ty < 0 || ty > 10 || tx + ty < 5 || tx + ty > 15) break;
				if(nextState.mine[pos] == 0 && nextState.next[pos] == 0 && nextState.prev[pos] == 0) break;
				if((enemy == 1 && nextState.next[pos] == 0) || (enemy == 2 && nextState.prev[pos] == 0)) {
        			for(int k = 0; k < 11; k++) {
        				tx -= dx[i], ty -= dy[i];
						pos = tx*11 + ty;
						if(nextState.mine[pos] == 1) {
							break;
						}
						nextState.mine.set(pos);
        				if(enemy == 1) {
							nextState.next.set(pos, 0);
						}
						else {
							nextState.prev.set(pos, 0);
						}
        			}
					break;
				}
				tx += dx[i], ty += dy[i];
				pos = tx*11 + ty;
			}
		}
	}
	std::bitset<121> temp = nextState.mine;
	nextState.mine = nextState.next;
	nextState.next = nextState.prev;
	nextState.prev = temp;
	return nextState;
}

bool legal_position(board_t &node, int x, int y) {
	bool legal = false;
	int dx[6] = { -1, -1, 0, 0, 1, 1 };
	int dy[6] = { 0, 1, -1, 1, -1, 0 };
	for(int i = 0; i < 6; i++) {
		int tx = x + dx[i], ty = y + dy[i];
		int pos = tx*11 + ty;
		if(tx < 0 || tx > 10 || ty < 0 || ty > 10 || tx + ty < 5 || tx + ty > 15 || node.mine[pos] == 1) continue;
		if(node.mine[pos] == 0 && node.next[pos] == 0 && node.prev[pos] == 0) continue;
		int enemy = (node.next[pos] == 1)? 1 : 2;
		for(int j = 0; j < 11; j++) {
			if(tx < 0 || tx > 10 || ty < 0 || ty > 10 || tx + ty < 5 || tx + ty > 15) break;
			if(node.mine[pos] == 0 && node.next[pos] == 0 && node.prev[pos] == 0) break;
			if((enemy == 1 && node.next[pos] == 0) || (enemy == 2 && node.prev[pos] == 0)) {
				legal = true;
				break;
			}
			tx += dx[i], ty += dy[i];
			pos = tx*11 + ty;
		}
		if(legal) break;
	}
	return legal;
}

std::string next_step(board_t &node)
{
	/*std::ofstream step_record;
	step_record.open("Move_record.txt", std::ios::app);
	assert(step_record);*/

	std::vector<int> steps; // 合法走步

	for(int x = 0; x < 11; x++) {
		for(int y = 0; y < 11; y++) {
			if(node.mine[x*11+y] == 1 || node.next[x*11+y] == 1 || node.prev[x*11+y] == 1 || x + y < 5 || x + y > 15) continue;
			if(legal_position(node, x, y)) {
				steps.push_back(x*11 + y);
			}
		}
	}

	if (steps.empty())
	{
		return "--";
	}

	//step_record.close();

	srand(time(NULL));

	return num_to_place(steps[rand() % steps.size()]);
}

void Print(board_t &node, int turn)
{
	printf("\n");
	printf("\n────────────────────────\n");
	for (int i = 1; i <= 121; i++)
	{
		if(turn == 0) {
			if(node.mine[i-1] == 1) printf(" R |");
			else if(node.next[i-1] == 1) printf(" G |");
			else if(node.prev[i-1] == 1) printf(" B |");
			else printf("  |");
		}
		else if(turn == 1) {
			if(node.mine[i-1] == 1) printf(" G |");
			else if(node.next[i-1] == 1) printf(" B |");
			else if(node.prev[i-1] == 1) printf(" R |");
			else printf("  |");
		}
		else {
			if(node.mine[i-1] == 1) printf(" B |");
			else if(node.next[i-1] == 1) printf(" R |");
			else if(node.prev[i-1] == 1) printf(" G |");
			else printf("  |");
		}

		if(i % 11 == 0) printf("\n────────────────────────\n");
	}
}

int place_to_num(std::string place)
{
	if(place == "--") //pass
		return 121;
	else if(place == "++") // resign pass
		return 122;

	return (int)(place[0] - 'A') * 11 + (int)(place[1] - '1');
}

std::string num_to_place(int num)
{
	if(num == 121) //pass
		return "--";
	else if(num == 122) // resign pass
		return "++";

	std::string place;
	switch(num / 11)
	{
	case 0:
		place.push_back('A');
		break;
	case 1:
		place.push_back('B');
		break;
	case 2:
		place.push_back('C');
		break;
	case 3:
		place.push_back('D');
		break;
	case 4:
		place.push_back('E');
		break;
	case 5:
		place.push_back('F');
		break;
	case 6:
		place.push_back('G');
		break;
	case 7:
		place.push_back('H');
		break;
	case 8:
		place.push_back('I');
		break;
	case 9:
		place.push_back('J');
		break;
	case 10:
		place.push_back('K');
		break;
	default :
		break;
	}

	switch(num % 11)
	{
	case 0:
		place.push_back('1');
		break;
	case 1:
		place.push_back('2');
		break;
	case 2:
		place.push_back('3');
		break;
	case 3:
		place.push_back('4');
		break;
	case 4:
		place.push_back('5');
		break;
	case 5:
		place.push_back('6');
		break;
	case 6:
		place.push_back('7');
		break;
	case 7:
		place.push_back('8');
		break;
	case 8:
		place.push_back('9');
		break;
	case 9:
		place.push_back(':');
		break;
	case 10:
		place.push_back(';');
		break;
	default:
		break;
	}
	return place;
}

