#include <stdio.h>
#include <string.h>

#include "Move_random.cpp"

#define COMMAND_NUM 19
const char* commands_name[COMMAND_NUM] = {
    "protocol_version",
    "name",
    "version",
    "known_command",
    "list_commands",
    "quit",
    "boardsize",
    "reset_board",
    "num_repetition",
    "num_moves_to_draw",
    "move",
    "flip",
    "genmove",
    "game_over",
    "ready",
    "time_settings",
    "time_left",
    "showboard",
    "init_board"
};

int main() {
    std::string write;
	char read[1024], *token;
    const char *data[100];
    int id, i;

    //Initial board
    board_t cur_board;
    cur_board.mine.set(49);
    cur_board.mine.set(71);
    cur_board.next.set(50);
    cur_board.next.set(60);
    cur_board.next.set(70);
    cur_board.prev.set(59);
    cur_board.prev.set(61);
    cur_board.step = 0;

    int move_turn = 0;

    // Game Loop
    do {
        write.clear();
        // read command
        fgets(read, 1024, stdin);

        printf("get= %s\n", read);
        // remove newline(\n)
        read[strlen(read) - 1] = '\0';
        // get command id
        token = strtok(read, " ");
        sscanf(token, "%d", &id);
        // get command name
        token = strtok(NULL, " ");
        // get command data
        i = 0;
        while ((token = strtok(NULL, " ")) != NULL) {
            data[i++] = token;
        }

        switch (id) {
        case 0: // protocol_version
            write = "1.1.0";
            break;
        case 1: /// name
            write = "Player";
            break;
        case 2: /// version
            write = "1.0.0";
            break;
        case 3: // known_command
            for (i = 0; i < COMMAND_NUM; i++) {
                if (strcmp(data[0], commands_name[i]) == 0) {
                    break;
                }
            }
            write = i == COMMAND_NUM ? "false" : "true";
            break;
        case 4: // list_commands
            for (int i = 0; i < COMMAND_NUM; i++) {
                write += commands_name[i];
                write += "\n";
            }
            break;
        case 5: /// quit
            break;
        case 6: /// boardsize
            break;
        case 7: /// reset_board
            {
                cur_board.mine.reset();
                cur_board.next.reset();
                cur_board.prev.reset();
            	cur_board.mine.set(49);
                cur_board.mine.set(71);
                cur_board.next.set(50);
                cur_board.next.set(60);
                cur_board.next.set(70);
                cur_board.prev.set(59);
                cur_board.prev.set(61);
                cur_board.step = 0;
				move_turn = 0;
				break;
            }
        case 8: // num_repetition
            break;
        case 9: // num_moves_to_draw
            break;
        case 10: /// move
            {
				cur_board = move(cur_board, place_to_num(data[0]));
                if(++move_turn == 3) move_turn = 0;
				Print(cur_board, move_turn);
				break;
            }
        case 11: // flip
            break;
        case 12: /// genmove
        	{
				write = next_step(cur_board);
				break;
        	}
        case 13: // game_over
            printf("game_over %s\n", data[0]);
            break;
        case 14: /// ready
            break;
        case 15: /// time_settings
            break;
        case 16: /// time_left
            break;
        case 17: // showboard
            break;
        case 18: // init_board
            break;
		default :
			break;
        }

        /// Send result to MGTP server
        printf("=%d %s\n", id, write.c_str());

        fflush(stdout);
        fflush(stderr);

    } while (id != 5); // Quit if receive a quit command

    return 0;
}
